// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package auditmanager provides the client and types for making API
// requests to AWS Audit Manager.
//
// Welcome to the AWS Audit Manager API reference. This guide is for developers
// who need detailed information about the AWS Audit Manager API operations,
// data types, and errors.
//
// AWS Audit Manager is a service that provides automated evidence collection
// so that you can continuously audit your AWS usage, and assess the effectiveness
// of your controls to better manage risk and simplify compliance.
//
// AWS Audit Manager provides pre-built frameworks that structure and automate
// assessments for a given compliance standard. Frameworks include a pre-built
// collection of controls with descriptions and testing procedures, which are
// grouped according to the requirements of the specified compliance standard
// or regulation. You can also customize frameworks and controls to support
// internal audits with unique requirements.
//
// Use the following links to get started with the AWS Audit Manager API:
//
//    * Actions (https://docs.aws.amazon.com/audit-manager/latest/APIReference/API_Operations.html):
//    An alphabetical list of all AWS Audit Manager API operations.
//
//    * Data types (https://docs.aws.amazon.com/audit-manager/latest/APIReference/API_Types.html):
//    An alphabetical list of all AWS Audit Manager data types.
//
//    * Common parameters (https://docs.aws.amazon.com/audit-manager/latest/APIReference/CommonParameters.html):
//    Parameters that all Query operations can use.
//
//    * Common errors (https://docs.aws.amazon.com/audit-manager/latest/APIReference/CommonErrors.html):
//    Client and server errors that all operations can return.
//
// If you're new to AWS Audit Manager, we recommend that you review the AWS
// Audit Manager User Guide (https://docs.aws.amazon.com/audit-manager/latest/userguide/what-is.html).
//
// See https://docs.aws.amazon.com/goto/WebAPI/auditmanager-2017-07-25 for more information on this service.
//
// See auditmanager package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/auditmanager/
//
// Using the Client
//
// To contact AWS Audit Manager with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS Audit Manager client AuditManager for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/auditmanager/#New
package auditmanager
