// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package elasticsearchservice

import (
	"github.com/aws/aws-sdk-go/private/protocol"
)

const (

	// ErrCodeAccessDeniedException for service response error code
	// "AccessDeniedException".
	//
	// An error occurred because user does not have permissions to access the resource.
	// Returns HTTP status code 403.
	ErrCodeAccessDeniedException = "AccessDeniedException"

	// ErrCodeBaseException for service response error code
	// "BaseException".
	//
	// An error occurred while processing the request.
	ErrCodeBaseException = "BaseException"

	// ErrCodeConflictException for service response error code
	// "ConflictException".
	//
	// An error occurred because the client attempts to remove a resource that is
	// currently in use. Returns HTTP status code 409.
	ErrCodeConflictException = "ConflictException"

	// ErrCodeDisabledOperationException for service response error code
	// "DisabledOperationException".
	//
	// An error occured because the client wanted to access a not supported operation.
	// Gives http status code of 409.
	ErrCodeDisabledOperationException = "DisabledOperationException"

	// ErrCodeInternalException for service response error code
	// "InternalException".
	//
	// The request processing has failed because of an unknown error, exception
	// or failure (the failure is internal to the service) . Gives http status code
	// of 500.
	ErrCodeInternalException = "InternalException"

	// ErrCodeInvalidPaginationTokenException for service response error code
	// "InvalidPaginationTokenException".
	//
	// The request processing has failed because of invalid pagination token provided
	// by customer. Returns an HTTP status code of 400.
	ErrCodeInvalidPaginationTokenException = "InvalidPaginationTokenException"

	// ErrCodeInvalidTypeException for service response error code
	// "InvalidTypeException".
	//
	// An exception for trying to create or access sub-resource that is either invalid
	// or not supported. Gives http status code of 409.
	ErrCodeInvalidTypeException = "InvalidTypeException"

	// ErrCodeLimitExceededException for service response error code
	// "LimitExceededException".
	//
	// An exception for trying to create more than allowed resources or sub-resources.
	// Gives http status code of 409.
	ErrCodeLimitExceededException = "LimitExceededException"

	// ErrCodeResourceAlreadyExistsException for service response error code
	// "ResourceAlreadyExistsException".
	//
	// An exception for creating a resource that already exists. Gives http status
	// code of 400.
	ErrCodeResourceAlreadyExistsException = "ResourceAlreadyExistsException"

	// ErrCodeResourceNotFoundException for service response error code
	// "ResourceNotFoundException".
	//
	// An exception for accessing or deleting a resource that does not exist. Gives
	// http status code of 400.
	ErrCodeResourceNotFoundException = "ResourceNotFoundException"

	// ErrCodeValidationException for service response error code
	// "ValidationException".
	//
	// An exception for missing / invalid input fields. Gives http status code of
	// 400.
	ErrCodeValidationException = "ValidationException"
)

var exceptionFromCode = map[string]func(protocol.ResponseMetadata) error{
	"AccessDeniedException":           newErrorAccessDeniedException,
	"BaseException":                   newErrorBaseException,
	"ConflictException":               newErrorConflictException,
	"DisabledOperationException":      newErrorDisabledOperationException,
	"InternalException":               newErrorInternalException,
	"InvalidPaginationTokenException": newErrorInvalidPaginationTokenException,
	"InvalidTypeException":            newErrorInvalidTypeException,
	"LimitExceededException":          newErrorLimitExceededException,
	"ResourceAlreadyExistsException":  newErrorResourceAlreadyExistsException,
	"ResourceNotFoundException":       newErrorResourceNotFoundException,
	"ValidationException":             newErrorValidationException,
}
