// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package iotsitewise

import (
	"github.com/aws/aws-sdk-go/private/protocol"
)

const (

	// ErrCodeConflictingOperationException for service response error code
	// "ConflictingOperationException".
	//
	// Your request has conflicting operations. This can occur if you're trying
	// to perform more than one operation on the same resource at the same time.
	ErrCodeConflictingOperationException = "ConflictingOperationException"

	// ErrCodeInternalFailureException for service response error code
	// "InternalFailureException".
	//
	// AWS IoT SiteWise can't process your request right now. Try again later.
	ErrCodeInternalFailureException = "InternalFailureException"

	// ErrCodeInvalidRequestException for service response error code
	// "InvalidRequestException".
	//
	// The request isn't valid. This can occur if your request contains malformed
	// JSON or unsupported characters. Check your request and try again.
	ErrCodeInvalidRequestException = "InvalidRequestException"

	// ErrCodeLimitExceededException for service response error code
	// "LimitExceededException".
	//
	// You've reached the limit for a resource. For example, this can occur if you're
	// trying to associate more than the allowed number of child assets or attempting
	// to create more than the allowed number of properties for an asset model.
	//
	// For more information, see Quotas (https://docs.aws.amazon.com/iot-sitewise/latest/userguide/quotas.html)
	// in the AWS IoT SiteWise User Guide.
	ErrCodeLimitExceededException = "LimitExceededException"

	// ErrCodeResourceAlreadyExistsException for service response error code
	// "ResourceAlreadyExistsException".
	//
	// The resource already exists.
	ErrCodeResourceAlreadyExistsException = "ResourceAlreadyExistsException"

	// ErrCodeResourceNotFoundException for service response error code
	// "ResourceNotFoundException".
	//
	// The requested resource can't be found.
	ErrCodeResourceNotFoundException = "ResourceNotFoundException"

	// ErrCodeServiceUnavailableException for service response error code
	// "ServiceUnavailableException".
	//
	// The requested service is unavailable.
	ErrCodeServiceUnavailableException = "ServiceUnavailableException"

	// ErrCodeThrottlingException for service response error code
	// "ThrottlingException".
	//
	// Your request exceeded a rate limit. For example, you might have exceeded
	// the number of AWS IoT SiteWise assets that can be created per second, the
	// allowed number of messages per second, and so on.
	//
	// For more information, see Quotas (https://docs.aws.amazon.com/iot-sitewise/latest/userguide/quotas.html)
	// in the AWS IoT SiteWise User Guide.
	ErrCodeThrottlingException = "ThrottlingException"

	// ErrCodeTooManyTagsException for service response error code
	// "TooManyTagsException".
	//
	// You've reached the limit for the number of tags allowed for a resource. For
	// more information, see Tag naming limits and requirements (https://docs.aws.amazon.com/general/latest/gr/aws_tagging.html#tag-conventions)
	// in the AWS General Reference.
	ErrCodeTooManyTagsException = "TooManyTagsException"

	// ErrCodeUnauthorizedException for service response error code
	// "UnauthorizedException".
	//
	// You are not authorized.
	ErrCodeUnauthorizedException = "UnauthorizedException"
)

var exceptionFromCode = map[string]func(protocol.ResponseMetadata) error{
	"ConflictingOperationException":  newErrorConflictingOperationException,
	"InternalFailureException":       newErrorInternalFailureException,
	"InvalidRequestException":        newErrorInvalidRequestException,
	"LimitExceededException":         newErrorLimitExceededException,
	"ResourceAlreadyExistsException": newErrorResourceAlreadyExistsException,
	"ResourceNotFoundException":      newErrorResourceNotFoundException,
	"ServiceUnavailableException":    newErrorServiceUnavailableException,
	"ThrottlingException":            newErrorThrottlingException,
	"TooManyTagsException":           newErrorTooManyTagsException,
	"UnauthorizedException":          newErrorUnauthorizedException,
}
