// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package polly

import (
	"github.com/aws/aws-sdk-go/private/protocol"
)

const (

	// ErrCodeEngineNotSupportedException for service response error code
	// "EngineNotSupportedException".
	//
	// This engine is not compatible with the voice that you have designated. Choose
	// a new voice that is compatible with the engine or change the engine and restart
	// the operation.
	ErrCodeEngineNotSupportedException = "EngineNotSupportedException"

	// ErrCodeInvalidLexiconException for service response error code
	// "InvalidLexiconException".
	//
	// Amazon Polly can't find the specified lexicon. Verify that the lexicon's
	// name is spelled correctly, and then try again.
	ErrCodeInvalidLexiconException = "InvalidLexiconException"

	// ErrCodeInvalidNextTokenException for service response error code
	// "InvalidNextTokenException".
	//
	// The NextToken is invalid. Verify that it's spelled correctly, and then try
	// again.
	ErrCodeInvalidNextTokenException = "InvalidNextTokenException"

	// ErrCodeInvalidS3BucketException for service response error code
	// "InvalidS3BucketException".
	//
	// The provided Amazon S3 bucket name is invalid. Please check your input with
	// S3 bucket naming requirements and try again.
	ErrCodeInvalidS3BucketException = "InvalidS3BucketException"

	// ErrCodeInvalidS3KeyException for service response error code
	// "InvalidS3KeyException".
	//
	// The provided Amazon S3 key prefix is invalid. Please provide a valid S3 object
	// key name.
	ErrCodeInvalidS3KeyException = "InvalidS3KeyException"

	// ErrCodeInvalidSampleRateException for service response error code
	// "InvalidSampleRateException".
	//
	// The specified sample rate is not valid.
	ErrCodeInvalidSampleRateException = "InvalidSampleRateException"

	// ErrCodeInvalidSnsTopicArnException for service response error code
	// "InvalidSnsTopicArnException".
	//
	// The provided SNS topic ARN is invalid. Please provide a valid SNS topic ARN
	// and try again.
	ErrCodeInvalidSnsTopicArnException = "InvalidSnsTopicArnException"

	// ErrCodeInvalidSsmlException for service response error code
	// "InvalidSsmlException".
	//
	// The SSML you provided is invalid. Verify the SSML syntax, spelling of tags
	// and values, and then try again.
	ErrCodeInvalidSsmlException = "InvalidSsmlException"

	// ErrCodeInvalidTaskIdException for service response error code
	// "InvalidTaskIdException".
	//
	// The provided Task ID is not valid. Please provide a valid Task ID and try
	// again.
	ErrCodeInvalidTaskIdException = "InvalidTaskIdException"

	// ErrCodeLanguageNotSupportedException for service response error code
	// "LanguageNotSupportedException".
	//
	// The language specified is not currently supported by Amazon Polly in this
	// capacity.
	ErrCodeLanguageNotSupportedException = "LanguageNotSupportedException"

	// ErrCodeLexiconNotFoundException for service response error code
	// "LexiconNotFoundException".
	//
	// Amazon Polly can't find the specified lexicon. This could be caused by a
	// lexicon that is missing, its name is misspelled or specifying a lexicon that
	// is in a different region.
	//
	// Verify that the lexicon exists, is in the region (see ListLexicons) and that
	// you spelled its name is spelled correctly. Then try again.
	ErrCodeLexiconNotFoundException = "LexiconNotFoundException"

	// ErrCodeLexiconSizeExceededException for service response error code
	// "LexiconSizeExceededException".
	//
	// The maximum size of the specified lexicon would be exceeded by this operation.
	ErrCodeLexiconSizeExceededException = "LexiconSizeExceededException"

	// ErrCodeMarksNotSupportedForFormatException for service response error code
	// "MarksNotSupportedForFormatException".
	//
	// Speech marks are not supported for the OutputFormat selected. Speech marks
	// are only available for content in json format.
	ErrCodeMarksNotSupportedForFormatException = "MarksNotSupportedForFormatException"

	// ErrCodeMaxLexemeLengthExceededException for service response error code
	// "MaxLexemeLengthExceededException".
	//
	// The maximum size of the lexeme would be exceeded by this operation.
	ErrCodeMaxLexemeLengthExceededException = "MaxLexemeLengthExceededException"

	// ErrCodeMaxLexiconsNumberExceededException for service response error code
	// "MaxLexiconsNumberExceededException".
	//
	// The maximum number of lexicons would be exceeded by this operation.
	ErrCodeMaxLexiconsNumberExceededException = "MaxLexiconsNumberExceededException"

	// ErrCodeServiceFailureException for service response error code
	// "ServiceFailureException".
	//
	// An unknown condition has caused a service failure.
	ErrCodeServiceFailureException = "ServiceFailureException"

	// ErrCodeSsmlMarksNotSupportedForTextTypeException for service response error code
	// "SsmlMarksNotSupportedForTextTypeException".
	//
	// SSML speech marks are not supported for plain text-type input.
	ErrCodeSsmlMarksNotSupportedForTextTypeException = "SsmlMarksNotSupportedForTextTypeException"

	// ErrCodeSynthesisTaskNotFoundException for service response error code
	// "SynthesisTaskNotFoundException".
	//
	// The Speech Synthesis task with requested Task ID cannot be found.
	ErrCodeSynthesisTaskNotFoundException = "SynthesisTaskNotFoundException"

	// ErrCodeTextLengthExceededException for service response error code
	// "TextLengthExceededException".
	//
	// The value of the "Text" parameter is longer than the accepted limits. For
	// the SynthesizeSpeech API, the limit for input text is a maximum of 6000 characters
	// total, of which no more than 3000 can be billed characters. For the StartSpeechSynthesisTask
	// API, the maximum is 200,000 characters, of which no more than 100,000 can
	// be billed characters. SSML tags are not counted as billed characters.
	ErrCodeTextLengthExceededException = "TextLengthExceededException"

	// ErrCodeUnsupportedPlsAlphabetException for service response error code
	// "UnsupportedPlsAlphabetException".
	//
	// The alphabet specified by the lexicon is not a supported alphabet. Valid
	// values are x-sampa and ipa.
	ErrCodeUnsupportedPlsAlphabetException = "UnsupportedPlsAlphabetException"

	// ErrCodeUnsupportedPlsLanguageException for service response error code
	// "UnsupportedPlsLanguageException".
	//
	// The language specified in the lexicon is unsupported. For a list of supported
	// languages, see Lexicon Attributes (https://docs.aws.amazon.com/polly/latest/dg/API_LexiconAttributes.html).
	ErrCodeUnsupportedPlsLanguageException = "UnsupportedPlsLanguageException"
)

var exceptionFromCode = map[string]func(protocol.ResponseMetadata) error{
	"EngineNotSupportedException":               newErrorEngineNotSupportedException,
	"InvalidLexiconException":                   newErrorInvalidLexiconException,
	"InvalidNextTokenException":                 newErrorInvalidNextTokenException,
	"InvalidS3BucketException":                  newErrorInvalidS3BucketException,
	"InvalidS3KeyException":                     newErrorInvalidS3KeyException,
	"InvalidSampleRateException":                newErrorInvalidSampleRateException,
	"InvalidSnsTopicArnException":               newErrorInvalidSnsTopicArnException,
	"InvalidSsmlException":                      newErrorInvalidSsmlException,
	"InvalidTaskIdException":                    newErrorInvalidTaskIdException,
	"LanguageNotSupportedException":             newErrorLanguageNotSupportedException,
	"LexiconNotFoundException":                  newErrorLexiconNotFoundException,
	"LexiconSizeExceededException":              newErrorLexiconSizeExceededException,
	"MarksNotSupportedForFormatException":       newErrorMarksNotSupportedForFormatException,
	"MaxLexemeLengthExceededException":          newErrorMaxLexemeLengthExceededException,
	"MaxLexiconsNumberExceededException":        newErrorMaxLexiconsNumberExceededException,
	"ServiceFailureException":                   newErrorServiceFailureException,
	"SsmlMarksNotSupportedForTextTypeException": newErrorSsmlMarksNotSupportedForTextTypeException,
	"SynthesisTaskNotFoundException":            newErrorSynthesisTaskNotFoundException,
	"TextLengthExceededException":               newErrorTextLengthExceededException,
	"UnsupportedPlsAlphabetException":           newErrorUnsupportedPlsAlphabetException,
	"UnsupportedPlsLanguageException":           newErrorUnsupportedPlsLanguageException,
}
