// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package ram

import (
	"github.com/aws/aws-sdk-go/private/protocol"
)

const (

	// ErrCodeIdempotentParameterMismatchException for service response error code
	// "IdempotentParameterMismatchException".
	//
	// A client token input parameter was reused with an operation, but at least
	// one of the other input parameters is different from the previous call to
	// the operation.
	ErrCodeIdempotentParameterMismatchException = "IdempotentParameterMismatchException"

	// ErrCodeInvalidClientTokenException for service response error code
	// "InvalidClientTokenException".
	//
	// A client token is not valid.
	ErrCodeInvalidClientTokenException = "InvalidClientTokenException"

	// ErrCodeInvalidMaxResultsException for service response error code
	// "InvalidMaxResultsException".
	//
	// The specified value for MaxResults is not valid.
	ErrCodeInvalidMaxResultsException = "InvalidMaxResultsException"

	// ErrCodeInvalidNextTokenException for service response error code
	// "InvalidNextTokenException".
	//
	// The specified value for NextToken is not valid.
	ErrCodeInvalidNextTokenException = "InvalidNextTokenException"

	// ErrCodeInvalidParameterException for service response error code
	// "InvalidParameterException".
	//
	// A parameter is not valid.
	ErrCodeInvalidParameterException = "InvalidParameterException"

	// ErrCodeInvalidResourceTypeException for service response error code
	// "InvalidResourceTypeException".
	//
	// The specified resource type is not valid.
	ErrCodeInvalidResourceTypeException = "InvalidResourceTypeException"

	// ErrCodeInvalidStateTransitionException for service response error code
	// "InvalidStateTransitionException".
	//
	// The requested state transition is not valid.
	ErrCodeInvalidStateTransitionException = "InvalidStateTransitionException"

	// ErrCodeMalformedArnException for service response error code
	// "MalformedArnException".
	//
	// The format of an Amazon Resource Name (ARN) is not valid.
	ErrCodeMalformedArnException = "MalformedArnException"

	// ErrCodeMissingRequiredParameterException for service response error code
	// "MissingRequiredParameterException".
	//
	// A required input parameter is missing.
	ErrCodeMissingRequiredParameterException = "MissingRequiredParameterException"

	// ErrCodeOperationNotPermittedException for service response error code
	// "OperationNotPermittedException".
	//
	// The requested operation is not permitted.
	ErrCodeOperationNotPermittedException = "OperationNotPermittedException"

	// ErrCodeResourceArnNotFoundException for service response error code
	// "ResourceArnNotFoundException".
	//
	// An Amazon Resource Name (ARN) was not found.
	ErrCodeResourceArnNotFoundException = "ResourceArnNotFoundException"

	// ErrCodeResourceShareInvitationAlreadyAcceptedException for service response error code
	// "ResourceShareInvitationAlreadyAcceptedException".
	//
	// The invitation was already accepted.
	ErrCodeResourceShareInvitationAlreadyAcceptedException = "ResourceShareInvitationAlreadyAcceptedException"

	// ErrCodeResourceShareInvitationAlreadyRejectedException for service response error code
	// "ResourceShareInvitationAlreadyRejectedException".
	//
	// The invitation was already rejected.
	ErrCodeResourceShareInvitationAlreadyRejectedException = "ResourceShareInvitationAlreadyRejectedException"

	// ErrCodeResourceShareInvitationArnNotFoundException for service response error code
	// "ResourceShareInvitationArnNotFoundException".
	//
	// The Amazon Resource Name (ARN) for an invitation was not found.
	ErrCodeResourceShareInvitationArnNotFoundException = "ResourceShareInvitationArnNotFoundException"

	// ErrCodeResourceShareInvitationExpiredException for service response error code
	// "ResourceShareInvitationExpiredException".
	//
	// The invitation is expired.
	ErrCodeResourceShareInvitationExpiredException = "ResourceShareInvitationExpiredException"

	// ErrCodeResourceShareLimitExceededException for service response error code
	// "ResourceShareLimitExceededException".
	//
	// The requested resource share exceeds the limit for your account.
	ErrCodeResourceShareLimitExceededException = "ResourceShareLimitExceededException"

	// ErrCodeServerInternalException for service response error code
	// "ServerInternalException".
	//
	// The service could not respond to the request due to an internal problem.
	ErrCodeServerInternalException = "ServerInternalException"

	// ErrCodeServiceUnavailableException for service response error code
	// "ServiceUnavailableException".
	//
	// The service is not available.
	ErrCodeServiceUnavailableException = "ServiceUnavailableException"

	// ErrCodeTagLimitExceededException for service response error code
	// "TagLimitExceededException".
	//
	// The requested tags exceed the limit for your account.
	ErrCodeTagLimitExceededException = "TagLimitExceededException"

	// ErrCodeTagPolicyViolationException for service response error code
	// "TagPolicyViolationException".
	//
	// The specified tag is a reserved word and cannot be used.
	ErrCodeTagPolicyViolationException = "TagPolicyViolationException"

	// ErrCodeUnknownResourceException for service response error code
	// "UnknownResourceException".
	//
	// A specified resource was not found.
	ErrCodeUnknownResourceException = "UnknownResourceException"
)

var exceptionFromCode = map[string]func(protocol.ResponseMetadata) error{
	"IdempotentParameterMismatchException":            newErrorIdempotentParameterMismatchException,
	"InvalidClientTokenException":                     newErrorInvalidClientTokenException,
	"InvalidMaxResultsException":                      newErrorInvalidMaxResultsException,
	"InvalidNextTokenException":                       newErrorInvalidNextTokenException,
	"InvalidParameterException":                       newErrorInvalidParameterException,
	"InvalidResourceTypeException":                    newErrorInvalidResourceTypeException,
	"InvalidStateTransitionException":                 newErrorInvalidStateTransitionException,
	"MalformedArnException":                           newErrorMalformedArnException,
	"MissingRequiredParameterException":               newErrorMissingRequiredParameterException,
	"OperationNotPermittedException":                  newErrorOperationNotPermittedException,
	"ResourceArnNotFoundException":                    newErrorResourceArnNotFoundException,
	"ResourceShareInvitationAlreadyAcceptedException": newErrorResourceShareInvitationAlreadyAcceptedException,
	"ResourceShareInvitationAlreadyRejectedException": newErrorResourceShareInvitationAlreadyRejectedException,
	"ResourceShareInvitationArnNotFoundException":     newErrorResourceShareInvitationArnNotFoundException,
	"ResourceShareInvitationExpiredException":         newErrorResourceShareInvitationExpiredException,
	"ResourceShareLimitExceededException":             newErrorResourceShareLimitExceededException,
	"ServerInternalException":                         newErrorServerInternalException,
	"ServiceUnavailableException":                     newErrorServiceUnavailableException,
	"TagLimitExceededException":                       newErrorTagLimitExceededException,
	"TagPolicyViolationException":                     newErrorTagPolicyViolationException,
	"UnknownResourceException":                        newErrorUnknownResourceException,
}
