// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package resourcegroups provides the client and types for making API
// requests to AWS Resource Groups.
//
// AWS Resource Groups lets you organize AWS resources such as Amazon EC2 instances,
// Amazon Relational Database Service databases, and Amazon S3 buckets into
// groups using criteria that you define as tags. A resource group is a collection
// of resources that match the resource types specified in a query, and share
// one or more tags or portions of tags. You can create a group of resources
// based on their roles in your cloud infrastructure, lifecycle stages, regions,
// application layers, or virtually any criteria. Resource Groups enable you
// to automate management tasks, such as those in AWS Systems Manager Automation
// documents, on tag-related resources in AWS Systems Manager. Groups of tagged
// resources also let you quickly view a custom console in AWS Systems Manager
// that shows AWS Config compliance and other monitoring data about member resources.
//
// To create a resource group, build a resource query, and specify tags that
// identify the criteria that members of the group have in common. Tags are
// key-value pairs.
//
// For more information about Resource Groups, see the AWS Resource Groups User
// Guide (https://docs.aws.amazon.com/ARG/latest/userguide/welcome.html).
//
// AWS Resource Groups uses a REST-compliant API that you can use to perform
// the following types of operations.
//
//    * Create, Read, Update, and Delete (CRUD) operations on resource groups
//    and resource query entities
//
//    * Applying, editing, and removing tags from resource groups
//
//    * Resolving resource group member ARNs so they can be returned as search
//    results
//
//    * Getting data about resources that are members of a group
//
//    * Searching AWS resources based on a resource query
//
// See https://docs.aws.amazon.com/goto/WebAPI/resource-groups-2017-11-27 for more information on this service.
//
// See resourcegroups package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/resourcegroups/
//
// Using the Client
//
// To contact AWS Resource Groups with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS Resource Groups client ResourceGroups for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/resourcegroups/#New
package resourcegroups
