// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package signer provides the client and types for making API
// requests to AWS Signer.
//
// AWS Signer is a fully managed code signing service to help you ensure the
// trust and integrity of your code.
//
// AWS Signer supports the following applications:
//
// With code signing for AWS Lambda, you can sign AWS Lambda deployment packages.
// Integrated support is provided for Amazon S3, Amazon CloudWatch, and AWS
// CloudTrail. In order to sign code, you create a signing profile and then
// use Signer to sign Lambda zip files in S3.
//
// With code signing for IoT, you can sign code for any IoT device that is supported
// by AWS. IoT code signing is available for Amazon FreeRTOS (http://docs.aws.amazon.com/freertos/latest/userguide/)
// and AWS IoT Device Management (http://docs.aws.amazon.com/iot/latest/developerguide/),
// and is integrated with AWS Certificate Manager (ACM) (http://docs.aws.amazon.com/acm/latest/userguide/).
// In order to sign code, you import a third-party code signing certificate
// using ACM, and use that to sign updates in Amazon FreeRTOS and AWS IoT Device
// Management.
//
// For more information about AWS Signer, see the AWS Signer Developer Guide
// (http://docs.aws.amazon.com/signer/latest/developerguide/Welcome.html).
//
// See https://docs.aws.amazon.com/goto/WebAPI/signer-2017-08-25 for more information on this service.
//
// See signer package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/signer/
//
// Using the Client
//
// To contact AWS Signer with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS Signer client Signer for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/signer/#New
package signer
