// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package ssm provides the client and types for making API
// requests to Amazon Simple Systems Manager (SSM).
//
// AWS Systems Manager is a collection of capabilities that helps you automate
// management tasks such as collecting system inventory, applying operating
// system (OS) patches, automating the creation of Amazon Machine Images (AMIs),
// and configuring operating systems (OSs) and applications at scale. Systems
// Manager lets you remotely and securely manage the configuration of your managed
// instances. A managed instance is any Amazon Elastic Compute Cloud instance
// (EC2 instance), or any on-premises server or virtual machine (VM) in your
// hybrid environment that has been configured for Systems Manager.
//
// This reference is intended to be used with the AWS Systems Manager User Guide
// (https://docs.aws.amazon.com/systems-manager/latest/userguide/).
//
// To get started, verify prerequisites and configure managed instances. For
// more information, see Setting up AWS Systems Manager (https://docs.aws.amazon.com/systems-manager/latest/userguide/systems-manager-setting-up.html)
// in the AWS Systems Manager User Guide.
//
// For information about other API actions you can perform on EC2 instances,
// see the Amazon EC2 API Reference (https://docs.aws.amazon.com/AWSEC2/latest/APIReference/).
// For information about how to use a Query API, see Making API requests (https://docs.aws.amazon.com/AWSEC2/latest/APIReference/making-api-requests.html).
//
// See https://docs.aws.amazon.com/goto/WebAPI/ssm-2014-11-06 for more information on this service.
//
// See ssm package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/ssm/
//
// Using the Client
//
// To contact Amazon Simple Systems Manager (SSM) with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Amazon Simple Systems Manager (SSM) client SSM for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/ssm/#New
package ssm
