// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package ssooidc provides the client and types for making API
// requests to AWS SSO OIDC.
//
// AWS Single Sign-On (SSO) OpenID Connect (OIDC) is a web service that enables
// a client (such as AWS CLI or a native application) to register with AWS SSO.
// The service also enables the client to fetch the user’s access token upon
// successful authentication and authorization with AWS SSO. This service conforms
// with the OAuth 2.0 based implementation of the device authorization grant
// standard (https://tools.ietf.org/html/rfc8628 (https://tools.ietf.org/html/rfc8628)).
//
// For general information about AWS SSO, see What is AWS Single Sign-On? (https://docs.aws.amazon.com/singlesignon/latest/userguide/what-is.html)
// in the AWS SSO User Guide.
//
// This API reference guide describes the AWS SSO OIDC operations that you can
// call programatically and includes detailed information on data types and
// errors.
//
// AWS provides SDKs that consist of libraries and sample code for various programming
// languages and platforms such as Java, Ruby, .Net, iOS, and Android. The SDKs
// provide a convenient way to create programmatic access to AWS SSO and other
// AWS services. For more information about the AWS SDKs, including how to download
// and install them, see Tools for Amazon Web Services (http://aws.amazon.com/tools/).
//
// See https://docs.aws.amazon.com/goto/WebAPI/sso-oidc-2019-06-10 for more information on this service.
//
// See ssooidc package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/ssooidc/
//
// Using the Client
//
// To contact AWS SSO OIDC with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS SSO OIDC client SSOOIDC for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/ssooidc/#New
package ssooidc
