// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package wellarchitected provides the client and types for making API
// requests to AWS Well-Architected Tool.
//
// This is the AWS Well-Architected Tool API Reference.
//
// The AWS Well-Architected Tool API provides programmatic access to the AWS
// Well-Architected Tool (http://aws.amazon.com/well-architected-tool) in the
// AWS Management Console (https://console.aws.amazon.com/wellarchitected).
//
// Managing workloads:
//
//    * CreateWorkload: Define a new workload.
//
//    * ListWorkloads: List workloads.
//
//    * GetWorkload: Get the properties of a workload.
//
//    * UpdateWorkload: Update the properties of a workload.
//
//    * DeleteWorkload: Delete a workload.
//
// Managing milestones:
//
//    * CreateMilestone: Create a milestone.
//
//    * ListMilestones: List milestones.
//
//    * GetMilestone: Get the properties of a milestone.
//
// Managing lenses:
//
//    * ListLenses: List the available lenses.
//
//    * AssociateLenses: Add one or more lenses to a workload.
//
//    * DisassociateLenses: Remove one or more lenses from a workload.
//
//    * ListNotifications: List lens notifications for a workload.
//
//    * GetLensVersionDifference: Get the differences between the version of
//    a lens used in a workload and the latest version.
//
//    * UpgradeLensReview: Upgrade a workload to use the latest version of a
//    lens.
//
// Managing reviews:
//
//    * ListLensReviews: List reviews associated with a workload.
//
//    * GetLensReview: Get pillar and risk data associated with a workload review.
//
//    * GetLensReviewReport: Get the report associated with a workload review.
//
//    * UpdateLensReview: Update the notes associated with a workload review.
//
//    * ListAnswers: List the questions and answers in a workload review.
//
//    * UpdateAnswer: Update the answer to a specific question in a workload
//    review.
//
//    * ListLensReviewImprovements: List the improvement plan associated with
//    a workload review.
//
// Managing workload shares:
//
//    * ListWorkloadShares: List the workload shares associated with a workload.
//
//    * CreateWorkloadShare: Create a workload share.
//
//    * UpdateWorkloadShare: Update a workload share.
//
//    * DeleteWorkloadShare: Delete a workload share.
//
// Managing workload share invitations:
//
//    * ListShareInvitations: List workload share invitations.
//
//    * UpdateShareInvitation: Update a workload share invitation.
//
// For information about the AWS Well-Architected Tool, see the AWS Well-Architected
// Tool User Guide (https://docs.aws.amazon.com/wellarchitected/latest/userguide/intro.html).
//
// See https://docs.aws.amazon.com/goto/WebAPI/wellarchitected-2020-03-31 for more information on this service.
//
// See wellarchitected package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/wellarchitected/
//
// Using the Client
//
// To contact AWS Well-Architected Tool with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS Well-Architected Tool client WellArchitected for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/wellarchitected/#New
package wellarchitected
